#ifndef HGLOBALS
#define HGLOBALS

#define ON  1
#define OFF 0

//  global iincludes
#include <stddef.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h> 
#include <avr/wdt.h>

// i2c bus baud rate
#define INTBUS_BAUD   100000UL 

// Global MACROs
#define _(x) (1 << (x))

// i2c devices
#define TWI_PC8574   0b01000000
#define TWI_PC8574A  0b01110000
#define TWI_LC512    0xa0
#define TWI_DS1307   0b11010000 // rtc
#define TWI_MCP23017 0b01000001

// 1w devices
#define OW_DS18B20   0x28 // Family code

#define SLA(x) (x<<1)

// eprom access

#define eROMrc(x) eeprom_read_byte((void*)&x)
#define eROMwc(x,y) eeprom_write_byte((void*)&x,(y))
#define eROMrb(x,y,z) eeprom_read_block((void*)&x, (void*)&y, z)
#define eROMwb(x,y,z) eeprom_write_block((void*)&x, (void*)&y, z)

#define eROM(x) eeprom_read_byte((void*)(x))

// delays
#include <util/delay.h>
void delay_ms(unsigned int ms) { while ((ms--) > 0) _delay_ms(1); }
void delay_us(unsigned int us) { while (us>45) {_delay_us(45); us-=45;} _delay_us(us); }

#endif

