/*
LCM ctrl program
Target: Atmega168P
*/

#include "globals.h"  	// global tools and contsants
#include "leds.c"  	// 595 leds
#include "i2ctools.c" 	// i2c

//    UART
void uart(uint8_t c) {
  while (!(UCSR0A & _(UDRE0))) ; UDR0 = c;
}

#define LEDS_BLOCKSIZE 	16 // Number of leds
#define LEDS_BLOCK_HB 	0x8000 // highest bit

// main routine
int main(void)
{

  int i;

  PORTD = 0b01010000;
  DDRD = 0b11110000;
  PORTC = 0b00000001;
  DDRC = 0b00000100;

  //   
  for(i=0; i<5; i++) {
     PORTD |= 0b00010000;
     delay_ms(500);
     PORTD &= ~0b00010000;
     delay_ms(500);
  }

  UBRR0L = 51;
  UBRR0H = 0; 	//  UBRR0 = 51   19200  16MHz;
  UCSR0A = 0;  	//  UCSR0A = (rU2X << U2X0);  
  UCSR0B = _(RXEN0)|_(TXEN0); //    
  UCSR0C = _(UCSZ01)|_(UCSZ00);  //  8 ,  , 1 -

  // test uart
  for(i=0; i<10; i++) {
    uart('L');
    uart('C');
    uart('M');
    uart('0'+i);
    uart(10);
    uart(13);
  }

  leds_init();
  delay_ms(500);

  // test signal leds
  for(i=0; i<16; i++) {
    leds_block(1<<i);  	
    delay_ms(500);
  }

  unsigned char sla = TWI_PC8574 | SLA(0);

  //      SLA==0
  for(i=0; i<8; i++) {
    twiStart(sla, (F_CPU/TWI_BAUD - 16)/2);  
    twiWrite(~(1<<i), ACK);
    twiStop();
    delay_ms(500);
  }

}
